#tag Module
Protected Module FieldExtension
	#tag Method, Flags = &h0
		Function ControlType(extends r as ReportField) As String
		  Static _ControlType As Xojo.Introspection.MethodInfo
		  If _ControlType = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "ControlType" Then
		        _ControlType = method
		        Exit For
		      End If
		    Next
		  End If
		  Return _ControlType.Invoke(r)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function GetAsXML(extends r as ReportField, data as string) As String
		  Static _GetAsXML As Xojo.Introspection.MethodInfo
		  If _GetAsXML = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "GetAsXML" Then
		        _GetAsXML = method
		        Exit For
		      End If
		    Next
		  End If
		  Dim a() As Auto
		  a.Append data
		  Return _GetAsXML.Invoke(r, a)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function LongDateMarker(extends r as ReportField, value as Boolean) As String
		  Static _LongDateMarker As Xojo.Introspection.MethodInfo
		  If _LongDateMarker = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "LongDateMarker" Then
		        _LongDateMarker = method
		        Exit For
		      End If
		    Next
		  End If
		  Dim a() As Auto
		  a.Append value
		  Return _LongDateMarker.Invoke(r, a)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function PageCountMarker(extends r as ReportField, value as Boolean) As String
		  Static _PageCountMarker As Xojo.Introspection.MethodInfo
		  If _PageCountMarker = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "PageCountMarker" Then
		        _PageCountMarker = method
		        Exit For
		      End If
		    Next
		  End If
		  Dim a() As Auto
		  a.Append value
		  Return _PageCountMarker.Invoke(r, a)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function PageNumberMarker(extends r as ReportField, value as Boolean) As String
		  Static _PageNumberMarker As Xojo.Introspection.MethodInfo
		  If _PageNumberMarker = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "PageNumberMarker" Then
		        _PageNumberMarker = method
		        Exit For
		      End If
		    Next
		  End If
		  Dim a() As Auto
		  a.Append value
		  Return _PageNumberMarker.Invoke(r, a)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function ShortDateMarker(extends r as ReportField, value as Boolean) As String
		  Static _ShortDateMarker As Xojo.Introspection.MethodInfo
		  If _ShortDateMarker = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "ShortDateMarker" Then
		        _ShortDateMarker = method
		        Exit For
		      End If
		    Next
		  End If
		  Dim a() As Auto
		  a.Append value
		  Return _ShortDateMarker.Invoke(r, a)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function SQLDateMarker(extends r as ReportField, value as Boolean) As String
		  Static _SQLDateMarker As Xojo.Introspection.MethodInfo
		  If _SQLDateMarker = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "SQLDateMarker" Then
		        _SQLDateMarker = method
		        Exit For
		      End If
		    Next
		  End If
		  Dim a() As Auto
		  a.Append value
		  Return _SQLDateMarker.Invoke(r, a)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function SQLDateTimeMarker(extends r as ReportField, value as Boolean) As String
		  Static _SQLDateTimeMarker As Xojo.Introspection.MethodInfo
		  If _SQLDateTimeMarker = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "SQLDateTimeMarker" Then
		        _SQLDateTimeMarker = method
		        Exit For
		      End If
		    Next
		  End If
		  Dim a() As Auto
		  a.Append value
		  Return _SQLDateTimeMarker.Invoke(r, a)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function TagPrefix(extends r as ReportField, value as Boolean) As String
		  Static _TagPrefix As Xojo.Introspection.MethodInfo
		  If _TagPrefix = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "TagPrefix" Then
		        _TagPrefix = method
		        Exit For
		      End If
		    Next
		  End If
		  Dim a() As Auto
		  a.Append value
		  Return _TagPrefix.Invoke(r, a)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function TagSuffix(extends r as ReportField, value as Boolean) As String
		  Static _TagSuffix As Xojo.Introspection.MethodInfo
		  If _TagSuffix = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "TagSuffix" Then
		        _TagSuffix = method
		        Exit For
		      End If
		    Next
		  End If
		  Dim a() As Auto
		  a.Append value
		  Return _TagSuffix.Invoke(r, a)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function XMLTextValue(extends r as ReportField) As String
		  Static _XMLTextValue As Xojo.Introspection.MethodInfo
		  If _XMLTextValue = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "GetXMLTextValue" Then
		        _XMLTextValue = method
		        Exit For
		      End If
		    Next
		  End If
		  Return _XMLTextValue.Invoke(r)
		End Function
	#tag EndMethod


	#tag ViewBehavior
		#tag ViewProperty
			Name="Name"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Index"
			Visible=true
			Group="ID"
			InitialValue="-2147483648"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Super"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Left"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Top"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
	#tag EndViewBehavior
End Module
#tag EndModule
